From bf85475d5820b054d991ace0d0ea907975e718ab Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Laur=C3=A9line=20Gu=C3=A9rin?= <zebuline@entrouvert.com>
Date: Tue, 9 Mar 2021 15:35:21 +0100
Subject: [PATCH] misc: store Role also in SQL (#51772)

---
 tests/admin_pages/test_all.py              |   9 +-
 tests/admin_pages/test_block.py            |   7 +-
 tests/admin_pages/test_card.py             |   9 +-
 tests/admin_pages/test_datasource.py       |   4 +-
 tests/admin_pages/test_form.py             | 143 ++++++-------
 tests/admin_pages/test_role.py             |  25 ++-
 tests/admin_pages/test_settings.py         |  37 ++--
 tests/admin_pages/test_user.py             |   6 +-
 tests/admin_pages/test_workflow.py         |  63 +++---
 tests/api/test_access.py                   |   9 +-
 tests/api/test_carddef.py                  |  25 ++-
 tests/api/test_category.py                 |   5 +-
 tests/api/test_custom_view.py              |  17 +-
 tests/api/test_formdata.py                 |  63 +++---
 tests/api/test_formdef.py                  |  17 +-
 tests/api/test_user.py                     |  13 +-
 tests/api/test_workflow.py                 |   9 +-
 tests/backoffice_pages/test_all.py         |  38 ++--
 tests/backoffice_pages/test_custom_view.py |   5 +-
 tests/form_pages/test_all.py               |  30 +--
 tests/form_pages/test_formdata.py          |  11 +-
 tests/test_formdata.py                     |   7 +-
 tests/test_formdef_import.py               |  13 +-
 tests/test_hobo_notify.py                  | 231 ++++++++++-----------
 tests/test_role.py                         |  31 ++-
 tests/test_saml_auth.py                    |  18 +-
 tests/test_snapshots.py                    |  28 +--
 tests/test_sql.py                          |   3 +-
 tests/test_workflow_import.py              |  43 ++--
 tests/test_workflows.py                    |  57 +++--
 tests/utilities.py                         |   4 +
 wcs/admin/forms.py                         |  10 +-
 wcs/admin/roles.py                         |  10 +-
 wcs/admin/settings.py                      |  14 +-
 wcs/admin/users.py                         |   9 +-
 wcs/api.py                                 |  13 +-
 wcs/backoffice/cards.py                    |   3 +-
 wcs/backoffice/management.py               |   4 +-
 wcs/ctl/hobo_notify.py                     |  11 +-
 wcs/formdata.py                            |   7 +-
 wcs/formdef.py                             |  10 +-
 wcs/publisher.py                           |  25 ++-
 wcs/qommon/saml2.py                        |   3 +-
 wcs/qommon/sessions.py                     |   1 -
 wcs/qommon/templatetags/qommon.py          |   6 +-
 wcs/roles.py                               |  67 +++++-
 wcs/sql.py                                 | 159 +++++++++++++-
 wcs/users.py                               |   5 +-
 wcs/variables.py                           |   4 +-
 wcs/wf/aggregation_email.py                |   3 +-
 wcs/wf/dispatch.py                         |   4 +-
 wcs/wf/notification.py                     |   3 +-
 wcs/wf/roles.py                            |   6 +-
 wcs/workflows.py                           |  22 +-
 54 files changed, 787 insertions(+), 592 deletions(-)

diff --git a/tests/admin_pages/test_all.py b/tests/admin_pages/test_all.py
index 3164bb56..70a5213f 100644
--- a/tests/admin_pages/test_all.py
+++ b/tests/admin_pages/test_all.py
@@ -6,7 +6,6 @@ import pytest
 
 from wcs.qommon.ident.password_accounts import PasswordAccount
 from wcs.qommon.http_request import HTTPRequest
-from wcs.roles import Role
 
 from utilities import get_app, login, create_temporary_pub, clean_temporary_pub
 
@@ -50,9 +49,9 @@ def create_superuser(pub):
     return user1
 
 
-def create_role():
-    Role.wipe()
-    role = Role(name='foobar')
+def create_role(pub):
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
     role.store()
     return role
 
@@ -96,7 +95,7 @@ def test_admin_redirect(pub):
 
 def test_admin_for_all(pub):
     user = create_superuser(pub)
-    role = create_role()
+    role = create_role(pub)
 
     try:
         open(os.path.join(pub.app_dir, 'ADMIN_FOR_ALL'), 'w').close()
diff --git a/tests/admin_pages/test_block.py b/tests/admin_pages/test_block.py
index c26e0200..7e680bb4 100644
--- a/tests/admin_pages/test_block.py
+++ b/tests/admin_pages/test_block.py
@@ -45,7 +45,7 @@ def teardown_module(module):
 
 def test_block_new(pub, blocks_feature):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
     BlockDef.wipe()
     app = login(get_app(pub))
     resp = app.get('/backoffice/forms/')
@@ -76,7 +76,6 @@ def test_block_new(pub, blocks_feature):
 
 def test_block_options(pub, blocks_feature):
     create_superuser(pub)
-    create_role()
     BlockDef.wipe()
     block = BlockDef()
     block.name = 'foobar'
@@ -134,7 +133,6 @@ def test_block_options_digest_template(pub, blocks_feature):
 
 def test_block_export_import(pub, blocks_feature):
     create_superuser(pub)
-    create_role()
     BlockDef.wipe()
     block = BlockDef()
     block.name = 'foobar'
@@ -182,7 +180,6 @@ def test_block_export_import(pub, blocks_feature):
 
 def test_block_delete(pub, blocks_feature):
     create_superuser(pub)
-    create_role()
     BlockDef.wipe()
     FormDef.wipe()
     block = BlockDef()
@@ -219,7 +216,6 @@ def test_block_delete(pub, blocks_feature):
 
 def test_block_edit_duplicate_delete_field(pub, blocks_feature):
     create_superuser(pub)
-    create_role()
     BlockDef.wipe()
     block = BlockDef()
     block.name = 'foobar'
@@ -248,7 +244,6 @@ def test_block_edit_duplicate_delete_field(pub, blocks_feature):
 
 def test_block_use_in_formdef(pub, blocks_feature):
     create_superuser(pub)
-    create_role()
     FormDef.wipe()
     BlockDef.wipe()
     block = BlockDef()
diff --git a/tests/admin_pages/test_card.py b/tests/admin_pages/test_card.py
index e2317400..2f84fc6a 100644
--- a/tests/admin_pages/test_card.py
+++ b/tests/admin_pages/test_card.py
@@ -9,7 +9,6 @@ from wcs.categories import CardDefCategory
 from wcs.carddef import CardDef
 from wcs.formdef import FormDef
 from wcs.qommon.http_request import HTTPRequest
-from wcs.roles import Role
 from wcs.wf.form import FormWorkflowStatusItem, WorkflowFormFieldsFormDef
 from wcs.workflows import Workflow
 from wcs.workflows import WorkflowBackofficeFieldsFormDef
@@ -357,8 +356,8 @@ def test_card_user_support(pub):
 
 def test_card_custom_view_data_source(pub):
     user = create_superuser(pub)
-    Role.wipe()
-    role = Role(name='foobar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
     role.store()
     user.roles = [role.id]
     user.store()
@@ -418,8 +417,8 @@ def test_card_custom_view_data_source(pub):
 
 def test_carddef_usage(pub):
     user = create_superuser(pub)
-    Role.wipe()
-    role = Role(name='foobar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
     role.store()
     user.roles = [role.id]
     user.store()
diff --git a/tests/admin_pages/test_datasource.py b/tests/admin_pages/test_datasource.py
index aff2cd91..63b68d18 100644
--- a/tests/admin_pages/test_datasource.py
+++ b/tests/admin_pages/test_datasource.py
@@ -23,7 +23,7 @@ from wcs.carddef import CardDef
 from wcs import fields
 
 from utilities import get_app, login, create_temporary_pub, clean_temporary_pub, HttpRequestsMocking
-from .test_all import create_superuser, create_role
+from .test_all import create_superuser
 
 
 def pytest_generate_tests(metafunc):
@@ -488,7 +488,6 @@ def test_data_sources_in_use_delete(pub):
 
 def test_data_sources_export(pub):
     create_superuser(pub)
-    create_role()
 
     NamedDataSource.wipe()
     data_source = NamedDataSource(name='foobar')
@@ -508,7 +507,6 @@ def test_data_sources_export(pub):
 
 def test_data_sources_import(pub):
     create_superuser(pub)
-    create_role()
 
     NamedDataSource.wipe()
     data_source = NamedDataSource(name='foobar')
diff --git a/tests/admin_pages/test_form.py b/tests/admin_pages/test_form.py
index 1293444e..94dfb989 100644
--- a/tests/admin_pages/test_form.py
+++ b/tests/admin_pages/test_form.py
@@ -17,7 +17,6 @@ from wcs.qommon.errors import ConnectionError
 from wcs.categories import Category
 from wcs.data_sources import NamedDataSource
 from wcs.wscalls import NamedWsCall
-from wcs.roles import Role
 from wcs.workflows import Workflow
 from wcs.formdef import FormDef
 from wcs.carddef import CardDef
@@ -53,18 +52,20 @@ def teardown_module(module):
 
 
 def test_forms(pub):
-    user = create_superuser(pub)
+    create_superuser(pub)
+    pub.role_class.wipe()
     app = login(get_app(pub))
     resp = app.get('/backoffice/forms/')
     assert 'You first have to define roles.' in resp.text
-    assert not 'New Form' in resp.text
+    assert 'New Form' not in resp.text
 
 
 def test_forms_new(pub):
     create_superuser(pub)
     app = login(get_app(pub))
-    create_role()
+    create_role(pub)
 
+    FormDef.wipe()
     # create a new form
     resp = app.get('/backoffice/forms/')
     assert 'New Form' in resp.text
@@ -80,14 +81,14 @@ def test_forms_new(pub):
     assert formdef.name == 'form title'
     assert formdef.url_name == 'form-title'
     assert formdef.fields == []
-    assert formdef.disabled == True
+    assert formdef.disabled is True
 
 
 def test_forms_new_popup(pub):
     FormDef.wipe()
     create_superuser(pub)
     app = login(get_app(pub))
-    create_role()
+    create_role(pub)
 
     # create a new form
     resp = app.get('/backoffice/forms/')
@@ -105,7 +106,7 @@ def test_forms_new_popup(pub):
     assert formdef.name == 'form title'
     assert formdef.url_name == 'form-title'
     assert formdef.fields == []
-    assert formdef.disabled == True
+    assert formdef.disabled is True
 
 
 def assert_option_display(resp, label, value):
@@ -116,7 +117,7 @@ def assert_option_display(resp, label, value):
 
 def test_forms_edit(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -138,7 +139,7 @@ def test_forms_edit(pub):
     assert resp.location == 'http://example.net/backoffice/forms/1/'
     resp = resp.follow()
     assert_option_display(resp, 'Confirmation Page', 'Disabled')
-    assert FormDef.get(1).confirmation == False
+    assert FormDef.get(1).confirmation is False
 
     # try cancel button
     resp = resp.click('Confirmation Page')
@@ -148,7 +149,7 @@ def test_forms_edit(pub):
     assert resp.location == 'http://example.net/backoffice/forms/1/'
     resp = resp.follow()
     assert_option_display(resp, 'Confirmation Page', 'Disabled')
-    assert FormDef.get(1).confirmation == False
+    assert FormDef.get(1).confirmation is False
 
     # Limit to one form
     assert_option_display(resp, 'Limit to one form', 'Disabled')
@@ -267,7 +268,7 @@ def test_forms_edit(pub):
 
 def test_form_title_change(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -320,7 +321,7 @@ def test_form_title_change(pub):
 
 def test_forms_edit_publication_date(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -355,7 +356,7 @@ def test_forms_edit_publication_date(pub):
 
 def test_form_category(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -379,7 +380,7 @@ def test_form_category(pub):
 
 def test_form_category_select(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -408,7 +409,7 @@ def test_form_category_select(pub):
 
 def test_form_workflow(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -432,7 +433,7 @@ def test_form_workflow(pub):
 
 def test_form_workflow_change(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -463,7 +464,7 @@ def test_form_workflow_change(pub):
 
 def test_form_workflow_link(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -487,7 +488,7 @@ def test_form_workflow_link(pub):
     assert '/backoffice/workflows/%s/' % workflow.id in resp.text
 
     # check workflow link is not displayed if user has no access right
-    pub.cfg['admin-permissions'] = {'workflows': ['x']}  #  block access
+    pub.cfg['admin-permissions'] = {'workflows': ['x']}  # block access
     pub.write_cfg()
     resp = app.get('/backoffice/forms/%s/' % formdef.id)
     assert '/backoffice/workflows/%s/' % workflow.id not in resp.text
@@ -495,7 +496,7 @@ def test_form_workflow_link(pub):
 
 def test_form_workflow_remapping(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -561,7 +562,7 @@ def test_form_workflow_remapping(pub):
 
 def test_form_submitter_roles(pub):
     create_superuser(pub)
-    role = create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -594,7 +595,7 @@ def test_form_submitter_roles(pub):
     assert FormDef.get(formdef.id).required_authentication_contexts == ['fedict']
 
     # check internal roles are not advertised
-    role2 = Role(name='internal')
+    role2 = pub.role_class(name='internal')
     role2.internal = True
     role2.store()
 
@@ -607,7 +608,7 @@ def test_form_submitter_roles(pub):
 
 def test_form_workflow_role(pub):
     create_superuser(pub)
-    role = create_role()
+    role = create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -627,7 +628,7 @@ def test_form_workflow_role(pub):
     assert FormDef.get(1).workflow_roles == {'_receiver': '1'}
 
     # check it doesn't fail if a second role with the same name exists
-    role = Role(name='foobar')
+    role = pub.role_class(name='foobar')
     role.store()
     resp = app.get('/backoffice/forms/1/')
     resp = resp.click(href='role/_receiver')
@@ -635,7 +636,7 @@ def test_form_workflow_role(pub):
 
 def test_form_workflow_options(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     Workflow.wipe()
     workflow = Workflow(name='Workflow One')
@@ -656,7 +657,7 @@ def test_form_workflow_options(pub):
 
 def test_form_workflow_variables(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -721,7 +722,7 @@ def test_form_workflow_variables(pub):
 
 def test_form_workflow_table_variables(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     Workflow.wipe()
     workflow = Workflow(name='Workflow One')
@@ -768,7 +769,7 @@ def test_form_workflow_table_variables(pub):
 
 def test_form_roles(pub):
     create_superuser(pub)
-    role = create_role()
+    role = create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -791,7 +792,7 @@ def test_form_roles(pub):
 
 def test_form_always_advertise(pub):
     create_superuser(pub)
-    role = create_role()
+    role = create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -866,7 +867,7 @@ def test_form_templates(pub):
 
 def test_form_delete(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -886,7 +887,7 @@ def test_form_delete(pub):
 
 def test_form_delete_with_data(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -920,7 +921,7 @@ def test_form_delete_with_data(pub):
 
 def test_form_duplicate(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -947,7 +948,7 @@ def test_form_duplicate(pub):
 
 def test_form_export(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -967,8 +968,8 @@ def test_form_export(pub):
 
 
 def test_form_import(pub):
-    user = create_superuser(pub)
-    role = create_role()
+    create_superuser(pub)
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1040,7 +1041,7 @@ def test_form_import(pub):
 
 def test_form_import_from_url(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1071,7 +1072,7 @@ def test_form_import_from_url(pub):
 
 def test_form_qrcode(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1090,7 +1091,7 @@ def test_form_qrcode(pub):
 
 def test_form_description(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1112,7 +1113,7 @@ def test_form_description(pub):
 
 def test_form_enable_from_fields_page(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1132,7 +1133,7 @@ def test_form_enable_from_fields_page(pub):
 
 def test_form_new_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1171,7 +1172,7 @@ def test_form_new_field(pub):
 
 def test_form_delete_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1198,7 +1199,7 @@ def test_form_delete_field(pub):
 
 def test_form_delete_field_existing_data(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1239,7 +1240,7 @@ def test_form_delete_field_existing_data(pub):
 
 def test_form_delete_page_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1286,8 +1287,8 @@ def test_form_delete_page_field(pub):
 
 
 def test_form_duplicate_field(pub):
-    user = create_superuser(pub)
-    create_role()
+    create_superuser(pub)
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1310,7 +1311,7 @@ def test_form_duplicate_field(pub):
 
 def test_form_duplicate_file_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1337,7 +1338,7 @@ def test_form_duplicate_file_field(pub):
 
 def test_form_edit_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1358,12 +1359,12 @@ def test_form_edit_field(pub):
     assert resp.location == 'http://example.net/backoffice/forms/1/fields/#itemId_1'
 
     assert FormDef.get(1).fields[0].label == 'changed field'
-    assert FormDef.get(1).fields[0].required == False
+    assert FormDef.get(1).fields[0].required is False
 
 
 def test_form_edit_field_advanced(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1436,7 +1437,7 @@ def test_form_edit_field_advanced(pub):
 
 def test_form_prefill_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1484,7 +1485,7 @@ def test_form_prefill_field(pub):
 
 def test_form_edit_string_field_validation(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1533,7 +1534,7 @@ def test_form_edit_string_field_validation(pub):
 
 def test_form_edit_item_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1560,7 +1561,7 @@ def test_form_edit_item_field(pub):
     resp = resp.follow()
 
     assert FormDef.get(1).fields[0].label == 'changed field'
-    assert FormDef.get(1).fields[0].required == False
+    assert FormDef.get(1).fields[0].required is False
     assert FormDef.get(1).fields[0].items is None
 
     # edit and fill with one item
@@ -1574,7 +1575,7 @@ def test_form_edit_item_field(pub):
 
 def test_form_edit_item_field_data_source(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1663,7 +1664,7 @@ def test_form_edit_item_field_data_source(pub):
 def test_form_edit_item_field_geojson_data_source(pub, http_requests):
     NamedDataSource.wipe()
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     NamedDataSource.wipe()
     data_source = NamedDataSource(name='foobar')
@@ -1702,7 +1703,7 @@ def test_form_edit_item_field_geojson_data_source(pub, http_requests):
 
 def test_form_edit_items_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1774,7 +1775,7 @@ def test_form_edit_items_field(pub):
 
 def test_form_edit_page_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1829,7 +1830,7 @@ def test_form_edit_page_field(pub):
 
 def test_form_edit_comment_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1919,7 +1920,7 @@ def test_form_comment_field_textwidget_validation(pub):
 
 def test_form_comment_field_wysiwygtextwidget_validation(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -1958,7 +1959,7 @@ def test_form_comment_field_wysiwygtextwidget_validation(pub):
 
 def test_form_edit_map_field(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2026,7 +2027,7 @@ def test_form_edit_map_field(pub):
 
 def test_form_edit_field_warnings(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2063,7 +2064,7 @@ def test_form_edit_field_warnings(pub):
 
 def test_form_limit_display_to_page(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2089,7 +2090,7 @@ def test_form_limit_display_to_page(pub):
 
 def test_form_fields_reorder(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2152,7 +2153,7 @@ def test_form_fields_reorder(pub):
 
 def test_form_move_page_fields(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2197,7 +2198,7 @@ def test_form_move_page_fields(pub):
 
 def test_form_legacy_int_id(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     Category.wipe()
     cat = Category(name='Foo')
@@ -2214,7 +2215,7 @@ def test_form_legacy_int_id(pub):
     formdef.name = 'form title'
     formdef.fields = []
 
-    role = Role(name='ZAB')  # Z to get sorted last
+    role = pub.role_class(name='ZAB')  # Z to get sorted last
     role.store()
 
     # set attributes using integers
@@ -2249,7 +2250,7 @@ def test_form_legacy_int_id(pub):
 
 def test_form_anonymise(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2316,7 +2317,7 @@ def test_form_anonymise(pub):
 
 def test_form_public_url(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2332,7 +2333,7 @@ def test_form_public_url(pub):
 
 def test_form_archive(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     if pub.is_using_postgresql():
         # this doesn't exist in SQL
@@ -2382,8 +2383,8 @@ def test_form_archive(pub):
 
 
 def test_form_overwrite(pub):
-    user = create_superuser(pub)
-    role = create_role()
+    create_superuser(pub)
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
@@ -2498,7 +2499,7 @@ def test_form_overwrite(pub):
 
 def test_form_export_import_export_overwrite(pub):
     create_superuser(pub)
-    create_role()
+    create_role(pub)
 
     FormDef.wipe()
     formdef = FormDef()
diff --git a/tests/admin_pages/test_role.py b/tests/admin_pages/test_role.py
index b73cb619..a61e3375 100644
--- a/tests/admin_pages/test_role.py
+++ b/tests/admin_pages/test_role.py
@@ -3,7 +3,6 @@
 import pytest
 
 from wcs.qommon.http_request import HTTPRequest
-from wcs.roles import Role
 from wcs.formdef import FormDef
 
 from utilities import get_app, login, create_temporary_pub, clean_temporary_pub
@@ -42,7 +41,7 @@ def test_roles(pub):
 
 def test_roles_new(pub):
     create_superuser(pub)
-    Role.wipe()
+    pub.role_class.wipe()
     app = login(get_app(pub))
     resp = app.get('/backoffice/roles/')
     resp = resp.click('New Role')
@@ -55,14 +54,14 @@ def test_roles_new(pub):
     resp = resp.click('a new role')
     assert '<h2>a new role' in resp.text
 
-    assert Role.get(1).name == 'a new role'
-    assert Role.get(1).details == 'bla bla bla'
+    assert pub.role_class.get(1).name == 'a new role'
+    assert pub.role_class.get(1).details == 'bla bla bla'
 
 
 def test_roles_edit(pub):
     create_superuser(pub)
-    Role.wipe()
-    role = Role(name='foobar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
     role.store()
 
     app = login(get_app(pub))
@@ -80,14 +79,14 @@ def test_roles_edit(pub):
     assert '<h2>baz' in resp.text
     assert 'Holders of this role will receive all emails adressed to the role.' in resp.text
 
-    assert Role.get(1).details == 'bla bla bla'
-    assert Role.get(1).emails_to_members is True
+    assert pub.role_class.get(1).details == 'bla bla bla'
+    assert pub.role_class.get(1).emails_to_members is True
 
 
 def test_roles_matching_formdefs(pub):
     create_superuser(pub)
-    Role.wipe()
-    role = Role(name='foo')
+    pub.role_class.wipe()
+    role = pub.role_class(name='foo')
     role.store()
 
     FormDef.wipe()
@@ -119,8 +118,8 @@ def test_roles_matching_formdefs(pub):
 
 def test_roles_delete(pub):
     create_superuser(pub)
-    Role.wipe()
-    role = Role(name='foobar')
+    pub.role_class.wipe()
+    role = pub.role_class(name='foobar')
     role.store()
 
     app = login(get_app(pub))
@@ -130,4 +129,4 @@ def test_roles_delete(pub):
     resp = resp.forms[0].submit()
     assert resp.location == 'http://example.net/backoffice/roles/'
     resp = resp.follow()
-    assert Role.count() == 0
+    assert pub.role_class.count() == 0
diff --git a/tests/admin_pages/test_settings.py b/tests/admin_pages/test_settings.py
index f3a0f41c..c2dcfac2 100644
--- a/tests/admin_pages/test_settings.py
+++ b/tests/admin_pages/test_settings.py
@@ -24,7 +24,6 @@ from wcs.api_access import ApiAccess
 from wcs.categories import Category, CardDefCategory
 from wcs.data_sources import NamedDataSource
 from wcs.wscalls import NamedWsCall
-from wcs.roles import Role
 from wcs.workflows import Workflow, CommentableWorkflowStatusItem
 from wcs.wf.export_to_model import ExportToModel
 from wcs.formdef import FormDef
@@ -32,7 +31,7 @@ from wcs.carddef import CardDef
 from wcs import fields
 
 from utilities import get_app, login, create_temporary_pub, clean_temporary_pub
-from .test_all import create_superuser, create_role
+from .test_all import create_superuser
 
 
 def pytest_generate_tests(metafunc):
@@ -97,7 +96,7 @@ def test_settings_export_import(pub):
         FormDef.wipe()
         CardDef.wipe()
         Workflow.wipe()
-        Role.wipe()
+        pub.role_class.wipe()
         Category.wipe()
         CardDefCategory.wipe()
         NamedDataSource.wipe()
@@ -133,7 +132,7 @@ def test_settings_export_import(pub):
     carddef.store()
     Category(name='baz').store()
     CardDefCategory(name='foobar').store()
-    Role(name='qux').store()
+    pub.role_class(name='qux').store()
     NamedDataSource(name='quux').store()
     ds = NamedDataSource(name='agenda')
     ds.external = 'agenda'
@@ -176,7 +175,8 @@ def test_settings_export_import(pub):
     assert 'workflows/1' not in filelist
     assert 'workflows_xml/1' in filelist
     assert 'models/export_to_model-1.upload' not in filelist
-    assert 'roles/1' in filelist
+    assert 'roles/1' not in filelist
+    assert 'roles_xml/1' in filelist
     assert 'categories/1' in filelist
     assert 'carddef_categories/1' in filelist
     assert 'datasources/1' in filelist
@@ -208,10 +208,11 @@ def test_settings_export_import(pub):
     assert CardDef.count() == 1
     assert CardDef.select()[0].url_name == 'bar'
     assert ApiAccess.count() == 1
+    assert pub.role_class.count() == 1
 
     # check roles are found by name
     wipe()
-    role = Role(name='qux')
+    role = pub.role_class(name='qux')
     role.store()
 
     workflow = Workflow(name='Workflow One')
@@ -250,14 +251,14 @@ def test_settings_export_import(pub):
     filelist = zipf.namelist()
     assert 'formdefs_xml/%s' % formdef.id in filelist
     assert 'workflows_xml/%s' % workflow.id in filelist
-    assert 'roles/%s' % role.id not in filelist
+    assert 'roles_xml/%s' % role.id not in filelist
 
     FormDef.wipe()
     Workflow.wipe()
-    Role.wipe()
+    pub.role_class.wipe()
 
     # create role beforehand, it should be matched by name
-    role = Role(name='qux')
+    role = pub.role_class(name='qux')
     role.id = '012345'
     role.store()
 
@@ -282,13 +283,13 @@ def test_settings_export_import(pub):
     zip_content = io.BytesIO(resp.body)
     zipf = zipfile.ZipFile(zip_content, 'a')
     filelist = zipf.namelist()
-    assert len([x for x in filelist if 'roles/' in x]) == 0
+    assert len([x for x in filelist if 'roles_xml/' in x]) == 0
 
     # check an error is displayed if such an import is then used and roles are
     # missing.
     FormDef.wipe()
     Workflow.wipe()
-    Role.wipe()
+    pub.role_class.wipe()
     resp = app.get('/backoffice/settings/import')
     resp.form['file'] = Upload('export.wcs', zip_content.getvalue())
     resp = resp.form.submit('submit')
@@ -579,7 +580,7 @@ def test_settings_idp(pub):
 
 
 def test_settings_auth_password(pub):
-    Role.wipe()
+    pub.role_class.wipe()
 
     pub.user_class.wipe()  # makes sure there are no users
     pub.cfg['identification'] = {'methods': ['password']}
@@ -724,12 +725,12 @@ def test_settings_geolocation(pub):
 
 def test_settings_permissions(pub):
     create_superuser(pub)
-    role1 = create_role()
-    role1.name = 'foobar1'
+    pub.role_class.wipe()
+    role1 = pub.role_class(name='foobar1')
     role1.store()
-    role2 = Role(name='foobar2')
+    role2 = pub.role_class(name='foobar2')
     role2.store()
-    role3 = Role(name='foobar3')
+    role3 = pub.role_class(name='foobar3')
     role3.store()
 
     app = login(get_app(pub))
@@ -749,8 +750,8 @@ def test_settings_permissions(pub):
     resp.forms[0]['permissions$c-0-0'].checked = False
     resp.forms[0]['permissions$c-1-0'].checked = True
     resp = resp.forms[0].submit()
-    assert Role.get(role1.id).allows_backoffice_access is False
-    assert Role.get(role2.id).allows_backoffice_access is True
+    assert pub.role_class.get(role1.id).allows_backoffice_access is False
+    assert pub.role_class.get(role2.id).allows_backoffice_access is True
 
     # give some roles access to the forms workshop (2nd checkbox) and to the
     # workflows workshop (4th)
